<?php
namespace Teknisa\CRM\Service;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Util\Functions;

class GeralService {

    /** 
     * @var GeralModel
     */
    protected $geralModel;
    protected $newCode;

    public function __construct( EntityManager $entityManager, $newCode) {
        $this->entityManager = $entityManager;
        $this->newCode       = $newCode;
    }

    public function getNextId($contador, $nrorg) {
        return \Util\NovoCodigo::geraCodigo($this->entityManager->getConnection(), $contador, $nrorg);
    }

    public function newContato(&$row) {
        $row['NRSEQCONTATO'] = $this->newCode->getCodeByTableName("NRSEQCONTATO", $row["NRORG"]);
        $row['NRCONTATO'] = $row['NRSEQCONTATO'];
        if(!\Zeedhi\Framework\Util\Functions::arrayKeyExists('CDFILIAL', $row)) $row['CDFILIAL'] = '9999';

        $query = "INSERT INTO CONTATO (CDPROSPECT, CDCLIENTE, CDFORNECED, DSREFECONT, IDSTATUSCONT, IDTPCONTATO, CDOPERCONT, NRORG, NRPARCNEGOCIO, IDATIVO, CDFILIAL, NRCONTATO, NRSEQCONTATO, DTHRCONTATO, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO)
        SELECT PROS.CDPROSPECT, CLIE.CDCLIENTE, FORN.CDFORNECED, :DSREFECONT, :IDSTATUSCONT, :IDTPCONTATO, :CDOPERCONT, :NRORG, :NRPARCNEGOCIO, 'S' AS IDATIVO, :CDFILIAL, :NRCONTATO, :NRSEQCONTATO, SYSDATE AS DTHRCONTATO, SYSDATE AS DTINCLUSAO, :NRORG AS NRORGINCLUSAO, :CDOPERCONT
        FROM PARCNEGOCIO PARC LEFT JOIN PROSPECT PROS
        ON PARC.NRPARCNEGOCIO = PROS.NRPARCNEGOCIO AND PARC.IDATIVO = PROS.IDATIVO AND PARC.NRORG = PROS.NRORG
        LEFT JOIN CLIENTE CLIE
        ON PARC.NRPARCNEGOCIO = CLIE.NRPARCNEGOCIO AND PARC.IDATIVO = CLIE.IDATIVO AND PARC.NRORG = CLIE.NRORG
        LEFT JOIN FORNECEDOR FORN
        ON PARC.NRPARCNEGOCIO = FORN.NRPARCNEGOCIO AND PARC.IDATIVO = FORN.IDATIVO AND PARC.NRORG = FORN.NRORG
        WHERE PARC.NRPARCNEGOCIO = :NRPARCNEGOCIO AND PARC.NRORG = :NRORG AND PARC.IDATIVO = 'S' AND ROWNUM = 1";

        try {
            $std = $this->entityManager->getConnection()->prepare($query);
            $params = array("DSREFECONT"=>substr('Referente a oportunidade '.$row['NMOPORT'], 0, 59),
                            "IDSTATUSCONT"=>'A',
                            "IDTPCONTATO"=>'P',
                            "NRPARCNEGOCIO"=>$row['NRPARCOPORT'],
                            "CDOPERCONT"=>$row['CDOPERCONT'],
                            "NRCONTATO"=>$row['NRSEQCONTATO'],
                            "NRSEQCONTATO"=>$row['NRSEQCONTATO'],
                            "NRORG"=>$row['NRORG'],
                            "CDFILIAL"=>$row['CDFILIAL']);
            $std->execute($params);
        }
        catch (\Exception $e) {
            $row['NRSEQCONTATO'] = '';
            $row['NRCONTATO']    = '';
        }
    }
}