function CRM_Operador_Controller(ScreenService, CRM_Operador_Repository, templateManager, restEngine, localStorageEngine, General)
{
    var self = this;
    self.operadorNewRow = function(widget)
    {
        self.masterDetailNewRow();
        this.setFilialField(widget, true);
        
        CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            widget.currentRow.NRORG = operator[0].NRORG;
            widget.currentRow.CDPAIS = "0055";
            widget.currentRow.NMPAIS = "Brasil";
            widget.currentRow.NRORGTRAB = operator[0].NRORG;
            self.blockCdoperadorField(widget, true);

            widget.currentRow.CDCLIENTE = null;
            widget.currentRow.CDEMPRESA = null;
            widget.currentRow.DTULTATUOPER = null;
            widget.currentRow.IDOPERACESSO = null;
            widget.currentRow.NRESTRUTTRAB = null;
            widget.currentRow.IDOPERMASTER = 'N';
            widget.currentRow.NRINSCRICAOPARC = null;
            widget.currentRow.NRORGSELECIONADA = null;
            widget.currentRow.CDFILIALSELECIONADA = null;
            widget.currentRow.NRPERFILSELECIONADO = null;

            restEngine.post('/crm_operadorTelaPrincipal/getOrganizacao', {'requestType':'Row', 'row': widget.currentRow},
                undefined, undefined, undefined).then(function(response)
                {
                    widget.currentRow.NMORGANIZACAO = response.dataset.DADOS.NMORGANIZACAO;
                });
            
        }.bind(this));
    };

    this.setFilialField = function(widget, visible){
        /*var loggedOperator = templateManager.LOGGEDOPERATOR;
        var filiaisField   = widget.getField('CDFILIAL');
        
        if(visible === true && loggedOperator.IDOPERMASTER === "S" && widget.currentRow.__is_new === true){
            filiaisField.showOnForm = true;
            if(widget.currentRow.IDOPERMASTER === "N")
                filiaisField.validations = {required:true};
            else
                filiaisField.validations = {};
        }else {
            filiaisField.showOnForm = false;
            filiaisField.validations = {};
        }*/
    };
    
    this.aplicaStylesGridSelect = function(fieldSelect){
        fieldSelect.selectWidget.styles = [
            {
                condition: "row.IDATIVO==='N'",
                cssClass: "coc-inactive"
            }
        ];
        fieldSelect.selectWidget.reload();
    };

    this.changeCase = function(field) {
        var valor = field.value();
        field.setValue(valor.toLowerCase());
        
        /*if (field.name == 'DSEMAILOPER') {
            field.widget.currentRow.DSEMAILOPER = field.widget.currentRow.DSEMAILOPER.toLowerCase();
            field.reload();
        }

        if (field.name == 'NMACESSO') {
            field.widget.currentRow.NMACESSO = field.widget.currentRow.NMACESSO.toUpperCase();
            field.reload();
        }*/
    };

    this.fillOperador = function(field){
        var widget = field.widget;
        var cdOper = widget.currentRow.CDOPERADOR;
        
        cdOper = '000000000000' + cdOper;
        cdOper = cdOper.substr(cdOper.length-12);
        widget.currentRow.CDOPERADOR = cdOper;
        field.reload();
    };

    self.blockCdoperadorField = function(widget, state)
    {
        widget.getField('CDOPERADOR').readOnly = state;
    };

    self.perfilNewRow = function(widget)
    {
        self.masterDetailNewRow();

        widget.getField('NMPERFILACESSO').showOnForm = false;
        var field = widget.getField('NMPERFILACESSO_MULT');
        field.showOnForm = true;
        field.dataSourceFilter[0].value = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        field.reload();

        widget.currentRow.NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
    };

    self.filialNewRow = function(widget)
    {
        self.masterDetailNewRow();

        widget.getField('NMFILIAL').showOnForm = false;
        var field = widget.getField('NMFILIAL_MULT');
        field.showOnForm = true;
        field.dataSourceFilter[0].value = widget.parent.parent.currentRow.CDOPERADOR;
        field.reload();

        CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
        {
            widget.currentRow.CDOPERADOR = widget.parent.parent.currentRow.CDOPERADOR;
            widget.currentRow.NRORGFILIAL = operator[0].NRORG;
            widget.currentRow.IDEXIBAVISO = null;
            widget.currentRow.DTULTATUFOPE = null;
        });
    };

    self.widgetEdit = function(widget, field)
    {
        widget.getField(field).showOnForm = true;
        widget.getField(field+'_MULT').showOnForm = false;
        widget.getField(field+'_MULT').validations = {};

        self.masterDetailEdit();
    };


    self.widgetCancel = function(widget, field)
    {
        widget.getField(field).showOnForm = true;
        widget.getField(field+'_MULT').showOnForm = false;
        widget.getField(field+'_MULT').validations = {"required": {}};

        self.masterDetailCancelForm();
    };

    self.defaultEditAuditRow = function(widget, operator)
    {
        var nrorg = operator[0].NRORG;
        var cdoperador = operator[0].CDOPERADOR;
        var dtinclusao = moment(new Date()).format('DD/MM/YYYY HH:mm');

        if(widget.currentRow.__is_new)
        {
            widget.currentRow.NRORG = nrorg;
            widget.currentRow.NRORGINCLUSAO = nrorg;
            widget.currentRow.CDOPERINCLUSAO = cdoperador;
            widget.currentRow.DTINCLUSAO = dtinclusao;
        }
        else
        {
            widget.currentRow.NRORGULTATU = nrorg;
            widget.currentRow.CDOPERULTATU = cdoperador;
            widget.currentRow.DTULTATU = dtinclusao;
        }
    };

    self.checkRequirements = function(widget)
    {
        if(!widget.isValid())
        {
            ScreenService.showMessage('Preencha todos os campos marcados com asterisco!');
            return false;
        }

        return true;
    };

    self.validaInscricao = function(widget)
    {
        if(isNaN(widget.currentRow.NRINSCRICAOPARC))
        {
            ScreenService.showMessage("Número de Inscrição Juridica deve ser um número válido.");
            return false;
        }

        return true;
    };

    self.checaInscricao = function(widget)
    {
        var nrinscricaoparc = widget.currentRow.NRINSCRICAOPARC;
        var checagem = true;

        if((nrinscricaoparc !== null) && (nrinscricaoparc !== undefined))
        {
            checagem = self.validaInscricao(widget);
            if(checagem)
            {
                if(nrinscricaoparc.length == 11)
                {
                    widget.currentRow.CDTIPOINSCRICAO = "CPF";
                }else if(nrinscricaoparc.length == 14)
                {
                    widget.currentRow.CDTIPOINSCRICAO = "CNPJ";
                }
                else
                {
                    widget.currentRow.CDTIPOINSCRICAO = "LIVRE";
                }
            }
        }
        else
        {
            widget.currentRow.CDTIPOINSCRICAO = "LIVRE";
        }

        return checagem;
    };

    self.saveOperador = function(widget)
    {
        if(widget.isValid() && self.checaInscricao(widget))
        {
            CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
            {
                var senha = widget.currentRow.CDSENHAOPERWEB;
                var confirmarSenha = widget.currentRow.CONFIRMAR_SENHA;
            
                if (senha === confirmarSenha) {    
                    
                    self.defaultEditAuditRow(widget, operator);
                    widget.currentRow.IDOPERATIVO = (widget.currentRow.IDATIVO == 'S') ? 'A' : 'I';
    
                    if(widget.currentRow.__is_new === false)
                    {
                        widget.currentRow.OLDNRINSCRICAOPARC = widget.backupRow.NRINSCRICAOPARC;
                        widget.currentRow.OLDCDCLIENTE = widget.backupRow.CDCLIENTE;
                        widget.currentRow.OLDCDSENHAOPERWEB = widget.backupRow.CDSENHAOPERWEB;
                        widget.currentRow.OLDNMOPERADOR = widget.backupRow.NMOPERADOR;
                    }
    
                    var cdOper = widget.currentRow.CDOPERADOR;
    
                    if(!widget.currentRow.NRINSCRICAOPARC) {
                        widget.currentRow.NRINSCRICAOPARC = cdOper;
                    } else {
                        widget.currentRow.NRINSCRICAOPARC = widget.currentRow.NRINSCRICAOPARC;
                    }
                    this.retornaFiliaisOperadorLogado().then(function(response){
                        if(templateManager.LOGGEDOPERATOR.IDOPERMASTER === "N"){
                           widget.currentRow.FILIAIS = response.map(function(filial){
                                return filial.CDFILIAL;   
                           }); 
                           widget.currentRow.IDOPERMASTERLOGADO = "N";
                        }
                        widget.saveRow().then(function(response)
                        {
                            widget.currentRow.changed = false;
                            widget.currentRow.__is_new = false;
                            
                            if(response.dataset) {
                                if(response.dataset.DADOS)
                                {
                                    if(response.dataset.DADOS.NRPARCNEGOCIO)
                                    {
                                        widget.currentRow.NRPARCNEGOCIO = response.dataset.DADOS.NRPARCNEGOCIO;
                                        widget.currentRow.CDOPERADOR = response.dataset.DADOS.CDOPERADOR;
                                    }
                                    //widget.currentRow.CDSENHOPER = response.dataset.DADOS.CDSENHOPER;
                                    if(response.dataset.DADOS.CDSENHAOPERWEB)
                                    {
                                        widget.currentRow.CDSENHAOPERWEB = response.dataset.DADOS.CDSENHAOPERWEB;
                                        widget.currentRow.CONFIRMAR_SENHA = response.dataset.DADOS.CDSENHAOPERWEB;
                                    }
                                }
                            }
                            self.blockCdoperadorField(widget, true);
        
                            self.changeWidgetVisibility(widget.widgets, true);
                            widget.list();
                            ScreenService.closeSwipe();
                            widget.reload();
                            this.setVisibilityFilialTab(widget);
                        }.bind(this)).catch(function(error){
                            if(error.data && error.data.error){
                                //tratando restrição unique de email
                                if(error.data.error.indexOf('USR_ORG_SAAS.UN_OPERADOR')  !== -1)
                                    ScreenService.showMessage("Operação bloqueada! <br><br> Já existe um operador com este email.");
                                else
                                    ScreenService.showMessage(error.data.error);
                            }
                        });
                    }.bind(this));
                }else {
                    ScreenService.showMessage("As senhas não correspondem.");
                }
            }.bind(this));
        }
    };

    self.savePerfil = function(widget)
    { 
        if(self.checkRequirements(widget))
        {
            CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
            {
                self.defaultEditAuditRow(widget, operator);

                if(widget.getField("NMPERFILACESSO_MULT").selectWidget) {
                
                    var rows = widget.getField("NMPERFILACESSO_MULT").selectWidget.getCheckedRows();
                    
                    rows.forEach(function(row) {
                        row.NRPARCNEGOCIO = widget.currentRow.NRPARCNEGOCIO;
                        row.NRPERFACESSOPAI = row.NRPERFILACESSO;
                        row.IDATIVO = widget.currentRow.IDATIVO;
                        row.DTVALPERFILPARC = "";
                        row.__new_code_pk = "PERFACESSPARC";
                        row.__table_pk = "NRPERFACESSPARC";
                        row.__cast_number = true;
                        row.__new_code_length = 20;    
                        row.__is_new = true;                
                        row.changed = true;
                        row.__using_unit = false;
                    });

                    General.callRestEngine("/crm_perfacessparcCompleto/save", "DataSet", rows).then(function(success) {
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    });
                } else {
                    widget.saveRow().then(function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        var msg = (error.data && error.data.error) ? 
                        msg = error.data.error : 'Registro já existente!';
                        ScreenService.showMessage(msg);
                    });
                }
            });
        }
    };

    self.saveFilial = function(widget)
    {
        if(self.checkRequirements(widget))
        {
            CRM_Operador_Repository.retornaOperadorLogado().then(function(operator)
            {
                self.defaultEditAuditRow(widget, operator);

                if(widget.getField("NMFILIAL_MULT").selectWidget) {
                
                    var rows = widget.getField("NMFILIAL_MULT").selectWidget.getCheckedRows();

                    rows.forEach(function(row) {
                        row.IDATIVO = widget.currentRow.IDATIVO;
                        row.__new_code_pk = "FILIAL";
                        row.__table_pk = "CDFILIAL";
                        row.__cast_number = true;
                        row.__new_code_length = 12;    
                        row.__is_new = true;                
                        row.changed = true;
                        row.__using_unit = false;
                    });
                    widget.saveRow().then(function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        var msg = (error.data && error.data.error) ? 
                        msg = error.data.error : 'Registro já existente!';
                        ScreenService.showMessage(msg);
                    });
                } else {
                    widget.saveRow().then(function(){
                        ScreenService.closeSwipe();
                        widget.activate();
                        widget.reload();
                    }, function(error) {
                        var msg = (error.data && error.data.error) ? 
                        msg = error.data.error : 'Registro já existente!';
                        ScreenService.showMessage(msg);
                    });
                }
            });
        }
    };

    self.iniciarDataSourceChild = function(widget)
    {
        var widPerf = widget.widgets[0];
        var widFili = widget.widgets[1];

        self.initTabGeneric(widPerf, "NRPARCNEGOCIO");
        self.initTabGeneric(widFili, "CDOPERADOR");
    };

    self.initTabGeneric = function(widget, field)
    {
        if(typeof widget === "string"){
            widget = templateManager.container.getWidget(widget);
        }
        if(widget.parent.parent.currentRow[field])
        {
            widget.dataSourceFilter[0].value = widget.parent.parent.currentRow[field];
            widget.reload();
        }
    };

    self.changeWidgetVisibility = function(widgets, isVisible) {
        widgets.forEach(function(widget){
            if(widget.name !== "wdgSenha"){
                widget.isVisible = isVisible;
                widget.enabled = true;
                widget.reload();
            }
        });
    };

    self.formChangeTemplate = function() {
        var widget = templateManager.container.getActiveWidget();

        if((widget.template != "widget/form.html")&&(widget.template != "widget/form-view.html")) return false;

        if(!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if(!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if(widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if(widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.goBackToDashboard = function() {
        ScreenService.openWindow('dashboard');
    };

    self.masterDetailCancelForm = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);

        if(widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if(indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            if(!self.formChangeTemplate()) widget.list();
            else widget.list();

            ScreenService.closeSwipe();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            self.formChangeTemplate();
            widget.view();
        }
    };

    self.masterDetailClosePopup = function() {
        var popup = templateManager.container.getActiveWidget();

        ScreenService.closePopup();
        popup.deactivate();
        popup.parentWidget.currentWidget = popup.parentWidget;
        popup.parentWidget.activate();
    };

    self.masterDetailDelete = function() {
        var widget = templateManager.container.getActiveWidget();
        ScreenService.confirmMessage("Deseja deletar o registro?", "CONFIRMATION", function() {
            widget.remove();
            self.masterDetailGoBackToList();
        }.bind(this));
    };

    self.masterDetailDeleteOper = function(row) {

        var widget = templateManager.container.getActiveWidget();
        
        ScreenService.confirmMessage("Deseja deletar o registro?", "CONFIRMATION", function() {
            General.callRestEngine("/operadorTelaPrincipal/remove", "Row", row).then(function(success) {
                ScreenService.closeSwipe();
                widget.activate();
                widget.reload();
            }, function(error) {
                var msg = (error.data && error.data.error) ?
                msg = error.data.error : 'Registro já existente!';
                ScreenService.showMessage(msg);
            });
        }.bind(this));
    };
    
    self.masterDetailEdit = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);
        self.formChangeTemplate();

        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    self.masterDetailGoBackToList = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe();
        widget.list();
    };

    self.masterDetailGoBackToParent = function() {
        var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function(){
            widget.parent.parent.list();
            widget.parent.parent.activate();
        });
    };

    self.masterDetailNewRow = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, false);

        widget.newRow();
    };

    /*self.masterDetailOpenPopup = function(name) {
        var widget = templateManager.container.getActiveWidget();

        var popup = widget.container.getWidget(name);
        popup.parentWidget = widget;
        ScreenService.openPopup(popup);
        ZhGridFilter.startFiltering();
    };*/

    self.masterDetailSave = function() {
        var widget = templateManager.container.getActiveWidget();

        self.changeWidgetVisibility(widget.widgets, true);
        self.formChangeTemplate();

        if(widget.isValid()) {
            widget.currentRow.changed = true;

            if(widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : getLocalVar('CRM_NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            } else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : getLocalVar('CRM_NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }

            return widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                widget.currentRow.__is_new = false;
                ScreenService.showMessage("Registro salvo com sucesso");
                ScreenService.closeSwipe();
                widget.list();
                widget.reload();
            }).catch(function(err) {
                ScreenService.showMessage(err.data.error);
            });
        }
    };

    self.unMask = function(columnName) {
        var widget = templateManager.container.getActiveWidget();

        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('R$') != -1)
            widget.currentRow[columnName] = $.currency.unmaskString(widget.currentRow[columnName], {"thousands": "."});
        if(widget.currentRow[columnName] && typeof widget.currentRow[columnName] === 'string' && widget.currentRow[columnName].indexOf('%') != -1)
            widget.currentRow[columnName] = parseFloat(widget.currentRow[columnName].replace(',', '.'));
    };

    self.wizardChangeFooter = function() {
        var widget = templateManager.container.getActiveWidget();

        widget.container.footer = (widget.container.footer == "component/footer.html")?
            "component/footer-wizard.html" : "component/footer.html";
    };

    self.wizardGoBack = function(){
        wizardEngine.previous();
    };

    self.wizardGoNext = function(){
        wizardEngine.next();
    };

    self.getValorEmReais = function(value)
    {
        var pad = "00";
        var valorFatura = value.split('.');

        if(valorFatura[1] === undefined)
        {
            valorFatura[1] = "";
        }
        valorFatura[1] = String(valorFatura[1]) + pad.substring(0, pad.length - String(valorFatura[1]).length);

        if(valorFatura[0] === '')
        {
            valorFatura[0] = "0";
        }
        var aux = "";
        for(var i = valorFatura[0].length - 1; i >= 0; i--)
        {
            if(((valorFatura[0].length -1 - i)%3 === 0) && (valorFatura[0].length -1 !== i))
            {
                aux += ".";
            }
            aux += valorFatura[0][i];
        }

        aux = aux.split("").reverse().join("");
        var valorEmReais = "R$ "+aux+","+valorFatura[1];
        return valorEmReais;
    };

    /*self.validateFilterPopup = function(args)
    {
        var filterPopup = templateManager.currentWidget;
        unidade = filterPopup.currentRow.CDFILIAL;
        if(!filterPopup.isValid())
            args.e.preventDefault();
    };*/
    
    this.wdgSenhaSetCurrentRow = function(widget) {
        widget.currentRow = widget.parent.dataSource.data[0];
    };
    
    this.wdgSenhaEditar = function(widget) {
        General.widgetEdit(widget);
        widget.currentRow.CDSENHAOPERWEB = "";
        widget.currentRow.CONFIRMAR_SENHA = "";
    };
    
    this.wdgSenhaSalvar = function(widget) {
        if (widget.isValid()) {
            var senha = widget.currentRow.CDSENHAOPERWEB;
            var confirmarSenha = widget.currentRow.CONFIRMAR_SENHA;
            
            if (senha === confirmarSenha) {
                restEngine.post('/crm_operadorTelaPrincipal/saveSenha', {'requestType':'Row', 'row': widget.currentRow})
                .then(function(response){
                    if(response.dataset) {
                        if(response.dataset.DADOS)
                        {
                            if(response.dataset.DADOS.CDSENHAOPERWEB)
                            {
                                widget.currentRow.CDSENHAOPERWEB = response.dataset.DADOS.CDSENHAOPERWEB;
                                widget.currentRow.CONFIRMAR_SENHA = response.dataset.DADOS.CDSENHAOPERWEB;
                            }
                        }
                        widget.parent.enabled = true;
                        widget.parent.parent.reload();
                        self.changeWidgetVisibility(widget.parent.parent.widgets, true);
                        self.wdgSenhaSetCurrentRow(widget);
                        widget.template = "widget/form-view.html";
                        widget.view();
                        
                        
                    }
                });
            }
            else {
                ScreenService.showMessage("As senhas não correspondem.");
            }
        }
    };
    
    this.setOrganOper = function(args){
        var widget = args;
        if (widget.isValid()) {
            widget.currentRow.NRORG = getLocalVar('CRM_NRORG') ? getLocalVar('CRM_NRORG') : " ";
            widget.currentRow.CDOPERADOR = widget.parent.parent.currentRow.CDOPERADOR;
            widget.currentRow.CDOPERINCLUSAO = getLocalVar('CRM_CDOPERADOR');
            return General.saveCrud(widget).then(function(response){
                widget.reload();
            });
           
        }
    };
    
    this.setVisibilityFilialTab = function(widget){
        var visible;
        if(templateManager.LOGGEDOPERATOR.IDOPERMASTER === "S"){
            visible = true;
        }else{
            visible = false;
        }
        if(widget.currentRow.__is_new !== true){
            widget.widgets.forEach(function(tab){
                if(tab.name === "FILIOPER"){
                    tab.isVisible = visible;
                }    
            });
        }
        this.setReadOnlyOperMasterField(widget, !visible);
    };
    
    this.setReadOnlyOperMasterField = function(widget, readOnly){
        widget.fields.forEach(function(field){
            if(field.name === "IDOPERMASTER"){
                field.readOnly = readOnly;
            }    
        });    
    };
    
    /**
     * Seta os filtros padrões
     * 
     * @param {object} widget widget de OPERADOR
    */
    this.defaultFilters = function(widget){
        var filter = widget.__filterPopup;
        var NMFILIAL, P_CDFILIAL, filiaisFilter, filialField = widget.getField('P_CDFILIAL');
        var idopermaster = templateManager.LOGGEDOPERATOR.IDOPERMASTER;
        
        if(idopermaster === "N"){
            this.retornaFiliaisOperadorLogado().then(function(response){
                P_CDFILIAL = response.map(function(filial){
                    return filial.CDFILIAL;   
                });
                NMFILIAL = response.map(function(filial){
                    return filial.NMFILIAL;   
                });
                filter.currentRow.P_CDFILIAL = P_CDFILIAL;
                filter.currentRow.NMFILIAL = NMFILIAL;
                
                filter.getField('P_CDFILIAL').reload();
                
                filiaisFilter = {
                   "name":"CDFILIAL",
                   "operator":"IN",
                   "value": angular.copy(P_CDFILIAL)
                };
                filialField.dataSourceFilter.push(filiaisFilter);
                
            });
        }else{
            this.retornaFiliaisOrg().then(function(response){
                P_CDFILIAL = response.map(function(filial){
                    return filial.CDFILIAL;   
                });
                NMFILIAL = response.map(function(filial){
                    return filial.NMFILIAL;   
                });
                filter.currentRow.P_CDFILIAL = P_CDFILIAL;
                filter.currentRow.NMFILIAL = NMFILIAL;
                
                filter.getField('P_CDFILIAL').reload();
            });    
        }
        
    };
    
    this.retornaFiliaisOrg = function() {
        var filter = [
            {
                "name": "NRORG",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.NRORG
            }
        ];
        return localStorageEngine.download("product#/crud/filial", filter);
    };
    
    this.retornaFiliaisOperadorLogado = function() {
        var filter = [
            {
                "name": "CDOPERADOR",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.CDOPERADOR
            },
            {
                "name": "NRORG",
                "operator": "=",
                "value": templateManager.LOGGEDOPERATOR.NRORG
            }
        ];
        return localStorageEngine.download("product#/crm_filioperCompleto", filter);
    };
    
    this.callDefaultFilters = function(widget){
        var field = widget.getField('P_CDFILIAL');
        
        if(Util.isEmptyOrBlank(field.value())){
            this.defaultFilters(templateManager.container.getWidget('OPERADOR'));    
        }
    };
    
    /*Replica mudanças no IDATIVO para o IDOPERATIVO*/
    this.changeIdoperativo  =function(widget){
        widget.currentRow.IDOPERATIVO = (widget.currentRow.IDATIVO === 'S') ? 'A' : (widget.currentRow.IDATIVO === 'N') ? 'I' : '';
    };
    
    this.prepareAtivoFilter = function(widget){
        widget.dataSourceFilter.forEach(function(filter, index, filters){
            if(filter.name === "IDATIVO"){
                filters.push({
                    "name":"IDOPERATIVO",
                    "operator": "=",
                    "static":true,
                    "value": (filter.value === 'S') ? 'A' : 'I'
                });
            }
        });
    }
    /*Fim*/
}

Configuration(function(ContextRegister)
{
    ContextRegister.register('CRM_Operador_Controller', CRM_Operador_Controller);
});