function ger01200_estadoController(ScreenService, General, Ger01200_Estado_Service) {

	this.salvar = function (widget) {
		if (widget.isValid()) {
			Ger01200_Estado_Service.salvarEstado(widget.currentRow).then(function (Success) {
					if (widget.currentRow.__is_new) {
						widget.reload().then(function () {
							widget.list(true);
							ScreenService.closeSwipe();
						});
					} else {
						widget.view();
					}
				}.bind(this),
				function (callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				});
		}
	};

	this.toAddCountry = function (args) {
		var arr = args.owner.widget.dataSourceFilter;
		var nm_pais = args.owner.widget.appliedFilter.FILTER_ROW.NMPAIS;
		var cd_pais = args.owner.widget.appliedFilter.FILTER_ROW.CDPAIS;
		args.owner.widget.newRow();
		args.owner.widget.currentRow.NMPAIS = nm_pais;
		args.owner.widget.currentRow.CDPAIS = cd_pais.toString();
	};

	this.controlaCampoEstado = function (widget) {
		var estado = widget.getField('NMESTADO');
		widget.currentRow.NMESTADO = '';
		widget.currentRow.SGESTADO = '';
		if (widget.currentRow.CDPAIS) {
			estado.readOnly = false;
		} else {
			estado.readOnly = true;
		}
	};

	this.setFiltroEstado = function (widget) {
			var estado = widget.getField('NMESTADO');
		estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
		estado.reload();
	};

	this.converteSiglaEstadoMaisculo = function (field) {
		field.value(field.value().toUpperCase());

	};
}

Configuration(function (ContextRegister) {
	ContextRegister.register('ger01200_estadoController', ger01200_estadoController);
});