function ron30001_classificacao_compromisso_controller(General, templateManager, Operador_Repository) {
    /**
     * Salva o registro de classificação de compromisso
     * 
     * @param {object} widget widget de classificação de compromisso
     * para setar campos da mesma
     */
    this.saveClassificacaoCompromisso = function(widget){
        
        if(widget.currentRow.__is_new){
            this.enableNewCodeNumber(widget);
        }
        
        widget.currentRow.__columns_to_return = ["NRCLASSIFICACOMPR"];
        
        this.setColorRGBtoHexadecimal(widget.currentRow);
        
        General.widgetSave(widget).then(function(response){
            if (response.dataset.columnsToReturn)
                widget.currentRow.NRCLASSIFICACOMPR = response.dataset.columnsToReturn.NRCLASSIFICACOMPR;
                
            this.desableNewCodeNumber(widget);
        });
    };
    /**
     * Seta as váriaveis de paramsNewCode 
     * para um novo código ser gerado.
     * 
     * @param {object} widget widget de classificação de compromisso
     * para setar os parametros de novo código
    */
    this.enableNewCodeNumber = function(widget){
        var paramsNewCode = widget.paramsNewCode;
        
        paramsNewCode.__is_new_code = true;
        paramsNewCode.__new_code_pk = "CRM_CLASSIFICACOMPR";
        paramsNewCode.__table_pk = "NRCLASSIFICACOMPR";
        paramsNewCode.__cast_number = true;
    };
    
    /**
     * Seta as váriaveis de paramsNewCode 
     * para um novo código não ser gerado.
     * 
     * @param {object} widget widget de concorrente
     * para setar os parametros de novo código
     */
    this.desableNewCodeNumber = function(widget){
        var paramsNewCode = widget.paramsNewCode;
        
        paramsNewCode.__is_new_code = false;
        paramsNewCode.__new_code_pk = "";
        paramsNewCode.__table_pk = "";
        paramsNewCode.__cast_number = true;
    };
    
    
    this.setColorRGBtoHexadecimal = function(currentRow){
        
        if(typeof currentRow.DSCORCLASSIFICACAO === "object"){
            var hexadecimal = currentRow.DSCORCLASSIFICACAO.toHexString();
            currentRow.DSCORCLASSIFICACAO = hexadecimal;
        }
    };
    
    
    this.setColor = function(row, element, widget){
        widget = templateManager.container.getWidget(widget);
        if(widget.mode === "edit"){
            
            element.children('p').remove();
            element.children('span').remove();
            element.children('div').remove();
            
            var class1 = "colorfield", class2 = "";
            
            class1 += " colorfield-in-grid";
            
            element.append('<div class='+class2+'> <div class='+class1+' style = background-color:'+ row.DSCORCLASSIFICACAO +';"> </div> </div>');
        }
    };
    
    /**
     * Altera o local da imagem que abre
     * no pop up para escolha da cor no campo
     * de cor após meio segundo.
    */
    this.changeImageLocal = function(){
            
        setTimeout(function(){
            document.getElementsByClassName('color-wheel')[0].src = "./assets/images/color-wheel.png";
        },500); 
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('ron30001_classificacao_compromisso_controller', ron30001_classificacao_compromisso_controller);
});